package com.yunfeiyun.agmp.common.web.system.controller;

import com.google.gson.Gson;
import com.yunfeiyun.agmp.common.config.SystemConfig;
import com.yunfeiyun.agmp.common.constant.Constants;
import com.yunfeiyun.agmp.common.constant.ErrorCode;
import com.yunfeiyun.agmp.common.constant.ResConstants;
import com.yunfeiyun.agmp.common.exception.BizException;
import com.yunfeiyun.agmp.common.framework.web.domain.UploadParam;
import com.yunfeiyun.agmp.common.web.system.domain.SysRes;
import com.yunfeiyun.agmp.common.core.controller.BaseController;
import com.yunfeiyun.agmp.common.core.domain.AjaxResult;
import com.yunfeiyun.agmp.common.framework.config.ServerConfig;
import com.yunfeiyun.agmp.common.framework.manager.ResManager;
import com.yunfeiyun.agmp.common.utils.StringUtils;
import com.yunfeiyun.agmp.common.utils.file.FileUploadUtils;
import com.yunfeiyun.agmp.common.utils.file.FileUtils;
import com.yunfeiyun.agmp.common.web.system.service.ISysResService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;

/**
 * 通用请求处理
 *
 * @author 杨晓辉
 */
@RestController
@RequestMapping("/common")
public class CommonController extends BaseController
{
    private static final Logger log = LoggerFactory.getLogger(CommonController.class);

    @Autowired
    private ServerConfig serverConfig;

    private static final String FILE_DELIMETER = ",";

    @Autowired
    private ISysResService sysResService;

    @Autowired
    private ResManager resManager;

    /**
     * 通用下载请求
     *
     * @param fileName 文件名称
     * @param delete 是否删除
     */
    @GetMapping("/download")
    public void fileDownload(String fileName, Boolean delete, HttpServletResponse response, HttpServletRequest request)
    {
        try
        {
            if (!FileUtils.checkAllowDownload(fileName))
            {
                throw new Exception(StringUtils.format("文件名称({})非法，不允许下载。 ", fileName));
            }
            String realFileName = System.currentTimeMillis() + fileName.substring(fileName.indexOf("_") + 1);
            String filePath = SystemConfig.getDownloadPath() + fileName;

            response.setContentType(MediaType.APPLICATION_OCTET_STREAM_VALUE);
            FileUtils.setAttachmentResponseHeader(response, realFileName);
            FileUtils.writeBytes(filePath, response.getOutputStream());
            if (delete)
            {
                FileUtils.deleteFile(filePath);
            }
        }
        catch (Exception e)
        {
            log.error("下载文件失败", e);
        }
    }

    /**
     * 通用上传请求（单个）
     */
    @PostMapping("/upload")
    public AjaxResult uploadFile(MultipartFile file, @RequestParam("UploadParam") String UploadParam) throws Exception
    {
        try {
            if (!file.isEmpty()) {
                com.yunfeiyun.agmp.common.framework.web.domain.UploadParam uploadParam = new Gson().fromJson(UploadParam, UploadParam.class);
                ResConstants.mediaType mediaType = ResConstants.mediaType.getKey(uploadParam.getResMediatype());
                ResConstants.BizType bizType = ResConstants.BizType.getKey(uploadParam.getResBiztype());
                if(mediaType == null){
                    throw new BizException(ErrorCode.INVALID_FORMAT.getCode(),ErrorCode.INVALID_FORMAT.getMessage());
                }
                if(bizType == null){
                    throw new BizException(ErrorCode.UPLOAD_BIZ_FAIL.getCode(),ErrorCode.UPLOAD_BIZ_FAIL.getMessage());
                }
                SysRes sysRes  = resManager.uploadRes( bizType, mediaType ,"",file,getLoginUser());
                AjaxResult ajax = AjaxResult.success();
                ajax.put("url", sysRes.getResUrl());
                ajax.put("resId", sysRes.getResId());
                return ajax;
            }
        }catch (Exception e){
            throw new BizException(ErrorCode.UPLOAD_FAIL.getCode(),ErrorCode.UPLOAD_FAIL.getMessage());
        }
        return AjaxResult.error(ErrorCode.UPLOAD_FAIL.getCode());
    }



    /**
     * 通用上传请求（多个）
     */
    @PostMapping("/uploads")
    public AjaxResult uploadFiles(List<MultipartFile> file, @RequestParam("UploadParam") String UploadParam) throws Exception
    {
        try
        {
            UploadParam uploadParam = new Gson().fromJson(UploadParam, UploadParam.class);
            // 上传文件路径
            List<String> urls = new ArrayList<String>();
            List<String> fileNames = new ArrayList<String>();
            List<String> newFileNames = new ArrayList<String>();
            List<String> originalFilenames = new ArrayList<String>();
            if(file != null){
                for (MultipartFile fileItem : file)
                {
                    String mediaTypeFile = FileUploadUtils.getMediaType(FileUploadUtils.getExtension(fileItem));
                    ResConstants.mediaType mediaType = ResConstants.mediaType.getKey(mediaTypeFile);
                    ResConstants.BizType bizType = ResConstants.BizType.getKey(uploadParam.getResBiztype());
                    if(mediaType == null){
                        throw new BizException(ErrorCode.INVALID_FORMAT.getCode(),ErrorCode.INVALID_FORMAT.getMessage());
                    }
                    if(bizType == null){
                        throw new BizException(ErrorCode.UPLOAD_BIZ_FAIL.getCode(),ErrorCode.UPLOAD_BIZ_FAIL.getMessage());
                    }
                    SysRes sysRes  = resManager.uploadRes( bizType, mediaType ,"",fileItem,getLoginUser());
                    if (sysRes !=null ) {
                        urls.add(sysRes.getResUrl());
                        fileNames.add(sysRes.getResUrl());
                        newFileNames.add(sysRes.getResUrl());
                        originalFilenames.add(fileItem.getOriginalFilename());
                    }

                }
                AjaxResult ajax = AjaxResult.success();
                ajax.put("resUrls", StringUtils.join(urls, FILE_DELIMETER));
                ajax.put("fileName", StringUtils.join(fileNames, FILE_DELIMETER));
                ajax.put("newFileNames", StringUtils.join(newFileNames, FILE_DELIMETER));
                ajax.put("originalFilenames", StringUtils.join(originalFilenames, FILE_DELIMETER));
                return ajax;
            }

        }
        catch (Exception e){
            throw new BizException(ErrorCode.UPLOAD_FAIL.getCode(),ErrorCode.UPLOAD_FAIL.getMessage());
        }
        return null;
    }


    /**
     * 本地资源通用下载
     */
    @GetMapping("/download/resource")
    public void resourceDownload(String resource, HttpServletRequest request, HttpServletResponse response)
            throws Exception
    {
        try
        {
            if (!FileUtils.checkAllowDownload(resource))
            {
                throw new Exception(StringUtils.format("资源文件({})非法，不允许下载。 ", resource));
            }
            // 本地资源路径
            String localPath = SystemConfig.getProfile();
            // 数据库资源地址
            String downloadPath = localPath + StringUtils.substringAfter(resource, Constants.RESOURCE_PREFIX);
            // 下载名称
            String downloadName = StringUtils.substringAfterLast(downloadPath, "/");
            response.setContentType(MediaType.APPLICATION_OCTET_STREAM_VALUE);
            FileUtils.setAttachmentResponseHeader(response, downloadName);
            FileUtils.writeBytes(downloadPath, response.getOutputStream());
        }
        catch (Exception e)
        {
            log.error("下载文件失败", e);
        }
    }


}
